/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is ForecastFox.
 *
 * The Initial Developer of the Original Code is
 * Richard Klein <richwklein@mchsi.com>.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Jon Stritar <jstritar@MIT.EDU>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gAbout = null;

function loadWfAbout() 
{
  gAbout = new about();
  gAbout.init();
} 

function unloadWfAbout()
{
  gAbout.destroy();
  gAbout = null;
}

function about()
{
  this.update = null;
  this.selectedPage = null;
  this.button = null;
  this.strings = null;
  this.iframe = null;
  
  return this;
}

about.prototype = {
  init: function()
  {
    //get update service
    this.update = Components.classes["@mozdev.org/forecastfox/update;1"]
                            .getService(Components.interfaces.nsIForecastfoxUpdate); 
    
    //set credit button                        
    this.button = document.documentElement.getButton("extra2");  
    this.strings = document.getElementById("wf_bundle");  
    this.button.setAttribute("label", this.strings.getString("wf.about.credits"));
    this.button.setAttribute("oncommand", "gAbout.switchPage();");

    //page switch variables
    this.iframe = document.getElementById("wf_creditsIframe");    
    this.selectedPage = 0;
    
    document.documentElement.getButton("accept").focus();                                
  },
  
  destroy: function()
  {
    this.iframe.setAttribute("src", "");
      
    this.update = null;
    this.selectedPage = null;
    this.button = null;
    this.strings = null;
    this.iframe = null;
  },
  
  switchPage: function()
  {
    if (this.selectedPage == 0) { 
      this.iframe.setAttribute("src", "chrome://forecastfox/content/about.xhtml");
      this.button.setAttribute("label", this.strings.getString("wf.about.label"));
      this.selectedPage = 1;
    }
    else {
      this.iframe.setAttribute("src", ""); 
      this.button.setAttribute("label", this.strings.getString("wf.about.credits"));
      this.selectedPage = 0;
    }
    var modes = document.getElementById("modes");
    modes.setAttribute("selectedIndex", this.selectedPage);  
  },
  
  open: function(aEvent, aTWC)
  {
    var url = aEvent.currentTarget.getAttribute("url");
    if (aTWC)
      url = url + "?prod=" + this.update.productCode + "&par=" + this.update.partnerId;

    var win = this.topWindow();
    var browser = win.document.getElementById("content");    
    browser.loadURI(url);  
  }, 
  
  topWindow: function()
  {
    //get a navigator window
    var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
    var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
    var win = windowManagerInterface.getMostRecentWindow("navigator:browser");
    if (!win) {
      win = window.openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank", null, null);
    }
    
    return win;  
  }
}
