/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is ForecastFox.
 *
 * The Initial Developer of the Original Code is
 * Jon Stritar <jstritar@MIT.EDU>.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Jon Stritar <jstritar@MIT.EDU>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
var wf_prof = null;

function profileCreateLoad() {
  wf_prof = new profileCreator();
  wf_prof.init();
}

function profileCreateUnload() {
  wf_prof.destroy();
  wf_prof = null;
}

function profileCreator() {
  return this;
}

profileCreator.prototype = 
{
  init: function()
  {
    this.wfProfile = Components.classes["@mozdev.org/forecastfox/profile;1"]
              .getService(Components.interfaces.nsIForecastfoxProfile);
    this.textBox = document.getElementById("new_name");
    this.sameName = document.getElementById("same_name");
    this.sameName.setAttribute("hidden", true);
    this.profList = window.opener.document.getElementById("wf_prof_list");
   
    this.acceptButton = document.documentElement.getButton("accept");
    this.acceptButton.setAttribute("disabled", true);
    
  },
  
  destroy: function()
  {
    this.wfProfile = null;
    this.textBox   = null;
    this.sameName = null;
    this.profList = null;
    this.acceptButton = null;
  },
  
  onChange: function()
  {
    if (this.textBox.value == "") {
      this.acceptButton.setAttribute("disabled", true);
      return;
    }
    
    var profiles = this.profList.childNodes;
    for (var x = 0; x < profiles.length; x++) {
      if (profiles[x].getAttribute("label").toLowerCase() == this.textBox.value.toLowerCase()) {
        this.acceptButton.setAttribute("disabled", true);
        this.sameName.removeAttribute("hidden");
        return;
      }
    }
    
    this.sameName.setAttribute("hidden", true);
    this.acceptButton.removeAttribute("disabled");
  },
  
  accept: function()
  {
    var name = this.textBox.value;
    this.wfProfile.saveProfile(name);
  }
};
