/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is ForecastFox.
 *
 * The Initial Developer of the Original Code is
 * Richard Klein <richwklein@mchsi.com>.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Richard Klein <richwklein@mchsi.com>
 *   Jon Stritar <jstritar@MIT.EDU>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

//global variables
var wfSearch = null;

function loadSearch()
{
  //create globals
  wfSearch = new search();

  // Disable ok
  document.documentElement.getButton("accept").setAttribute("disabled",true);
}

function saveSearch()
{
  var tree = document.getElementById("result_tree");

  //if nothing selected return
  if (tree.currentIndex == -1)
    return;

  //if no location return
  var current = tree.view.getItemAtIndex(tree.currentIndex).getAttribute("id");
  if (current == "na")
    return;

  //set location value
  var locid = window.opener.document.getElementById("locidinput");
  locid.value = current;

}

function unloadSearch()
{
  //destroy variables to prevent leaks
  wfSearch.request = null;
  wfSearch = null;
}

function search()
{
  //set base variables
  this.baseURL = "http://xoap.weather.com/search/search?where=";
  this.URL = null;
  this.request = null;

  //return reference to self
  return this;
}

search.prototype =
{

  enable: function(aString)
  {
    var button = document.getElementById("search_button");

    //if string exists then enable search button
    if (aString.value)
      button.removeAttribute("disabled");
    else
      button.setAttribute("disabled", "true");
  },
  
  enableAccept: function()
  {
    var accept = document.documentElement.getButton("accept");
    if (document.getElementById("result_tree").currentIndex == -1)
      accept.setAttribute("disabled",true);
    else
      accept.removeAttribute("disabled");
  },
  
  run: function()
  {
    //remove old search
    var results = document.getElementById("result_items");
    while (results.hasChildNodes())
      results.removeChild(results.lastChild);

    //set url
    this.URL = encodeURI(this.baseURL + document.getElementById("search_string").value);

    //setup request and send
    this.request = "@mozilla.org/xmlextras/xmlhttprequest;1";
    this.request = Components.classes[this.request].createInstance(Components.interfaces.nsIXMLHttpRequest);
    this.request.open("GET", this.URL, true);
    this.request.overrideMimeType("text/xml");
    this.request.onload = wfSearch.onDownloaded;
    this.request.onerror = wfSearch.onDownloadError;
    this.request.send(null);
  },
  
  onDownloaded: function(aEvent)
  {
    var response = wfSearch.request.responseXML;
    var status = wfSearch.request.status;
    var strings = document.getElementById("wfBundle");
    var treeitem, treerow, treecell1, treecell2, treecell3;


    //response error
    if (!response || status > 200) {
      treeitem = document.getElementById("result_items").appendChild(document.createElement("treeitem"));
      treerow = treeitem.appendChild(document.createElement("treerow"));
      treecell1 = treerow.appendChild(document.createElement("treecell"));
      treecell2 = treerow.appendChild(document.createElement("treecell"));
      treecell3 = treerow.appendChild(document.createElement("treecell"));
      treeitem.setAttribute("id", "na");
      treecell1.setAttribute("label", strings.getString("wfsearch.error"));
      treecell2.setAttribute("label", "");
      treecell3.setAttribute("label", "");
      return;
    }

    //no locations
    var locs = response.getElementsByTagName("loc");
    if (locs.length == 0) {
      treeitem = document.getElementById("result_items").appendChild(document.createElement("treeitem"));
      treerow = treeitem.appendChild(document.createElement("treerow"));
      treecell1 = treerow.appendChild(document.createElement("treecell"));
      treecell2 = treerow.appendChild(document.createElement("treecell"));
      treecell3 = treerow.appendChild(document.createElement("treecell"));
      treeitem.setAttribute("id", "na");
      treecell1.setAttribute("label", strings.getString("wf.search.noloc"));
      treecell2.setAttribute("label", "");
      treecell3.setAttribute("label", "");
      return;
    }

    for (var i=0; i < locs.length; i++) {
      treeitem = document.getElementById("result_items").appendChild(document.createElement("treeitem"));
      treerow = treeitem.appendChild(document.createElement("treerow"));
      treecell1 = treerow.appendChild(document.createElement("treecell"));
      treecell2 = treerow.appendChild(document.createElement("treecell"));
      treecell3 = treerow.appendChild(document.createElement("treecell"));
      treeitem.setAttribute("id", locs[i].getAttribute("id"));
      treecell1.setAttribute("label", locs[i].childNodes[0].nodeValue);
      treecell2.setAttribute("label", locs[i].getAttribute("id"));
      treecell3.setAttribute("label", locs[i].getAttribute("type"));
    }
    return;
  },
  
  onDownloadError: function(aEvent)
  {
    treeitem = document.getElementById("result_items").appendChild(document.createElement("treeitem"));
    treerow = treeitem.appendChild(document.createElement("treerow"));
    treecell1 = treerow.appendChild(document.createElement("treecell"));
    treecell2 = treerow.appendChild(document.createElement("treecell"));
    treecell3 = treerow.appendChild(document.createElement("treecell"));
    treeitem.setAttribute("id", "na");
    treecell1.setAttribute("label", strings.getString("wf.search.error"));
    treecell2.setAttribute("label", "");
    treecell3.setAttribute("label", "");
    return;
  }
}
